REST API reference
Public API operations and schemas.
# REST API reference
## agentIdentity
### GET /agent/identity
Operation ID: `agent.getIdentity`
Responses:
- `200` Success
```json
{"type":"object","properties":{"registrationId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"grantId":{"$ref":"#/components/schemas/OpaqueId"},"kind":{"type":"string","enum":["service_auth","identity_assertion","organization_api_key","internal_workflow","mcp_client_grant"]},"status":{"type":"object","properties":{"status":{"type":"string","enum":["active","interaction_required","expired","revoked","suspended"]},"reasonCode":{"type":"string","enum":["actor_removed","credential_expired","link_required","provider_revoked","admin_revoked","policy_suspended"]}},"required":["status"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["status","reasonCode"]}},"actorUserId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"organization":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/ShortText"},"slug":{"$ref":"#/components/schemas/ShortText"}},"required":["id","name","slug"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","slug"]}},"provider":{"anyOf":[{"type":"object","properties":{"issuer":{"$ref":"#/components/schemas/ProviderId"},"displayName":{"$ref":"#/components/schemas/ShortText"}},"required":["issuer","displayName"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["issuer","displayName"]}},{"type":"null"}]},"grantedScopes":{"type":"array","items":{"type":"string","enum":["agent:capabilities","agent:identity","agent:operations:cancel","agent:operations:read","analytics:export","analytics:read","apiKey:create","apiKey:delete","apiKey:read","apiKey:update","audit:read","billing:manage","billing:read","blocklist:create","blocklist:delete","blocklist:read","campaign:archive","campaign:create","campaign:delete","campaign:launch","campaign:pause","campaign:read","campaign:update","dialer:assign_numbers","dialer:assign_seats","dialer:create","dialer:delete","dialer:dial","dialer:manage_billing","dialer:manage_number_health","dialer:manage_numbers","dialer:manage_numbers_self","dialer:manage_voicemails","dialer:read","dialer:read_analytics","dialer:read_numbers_all","dialer:release_numbers","dialer:update","domain:manage_dns","domain:purchase","domain:read","domain:transfer","emailVerification:manage_credits","emailVerification:manage_keys","emailVerification:manage_sharing","emailVerification:read","emailVerification:verify","inbox:connect","inbox:create","inbox:delete","inbox:read","inbox:update","inbox:warmup_manage","integration:create","integration:delete","integration:read","integration:update","lead:create","lead:delete","lead:export","lead:import","lead:read","lead:update","leadList:create","leadList:delete","leadList:read","leadList:update","org:delete","orgAnalytics:read","orgAnalytics:manage","org:read","org:update","orgApiKey:manage","orgMember:invite","orgMember:read","orgMember:remove","orgMember:update","phoneVerification:manage_keys","phoneVerification:read","phoneVerification:verify","platform:operate","replyLabel:create","replyLabel:delete","replyLabel:read","replyLabel:update","role:manage","role:read","sequence:create","sequence:delete","sequence:read","sequence:update","sql:manage_dashboards","sql:query","support:create","support:read","support:update","tag:create","tag:delete","tag:read","tag:update","task:create","task:delete","task:read","task:update","template:create","template:delete","template:read","template:update","unibox:archive","unibox:label","unibox:read","unibox:reply","usage:read","webhook:create","webhook:delete","webhook:read","webhook:update","whiteLabel:read","whiteLabel:update","workflow:create","workflow:delete","workflow:publish","workflow:read","workflow:run","workflow:update","workspace:create","workspace:delete","workspace:read","workspace:transfer","workspace:update","workspaceMember:invite","workspaceMember:read","workspaceMember:remove","workspaceMember:update"]}},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"lastUsedAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]},"expiresAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["registrationId","kind","status","actorUserId","organization","provider","grantedScopes","createdAt","lastUsedAt","expiresAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["registrationId","grantId","kind","status","actorUserId","organization","provider","grantedScopes","createdAt","lastUsedAt","expiresAt"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /agent/workspaces
Operation ID: `agent.listWorkspaces`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/ShortText"},"slug":{"$ref":"#/components/schemas/ShortText"},"effectiveRoleLabel":{"$ref":"#/components/schemas/ShortText"},"capabilityBundles":{"type":"array","items":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}},"accessSource":{"type":"string","enum":["membership","organization","credential"]}},"required":["id","name","slug","effectiveRoleLabel","capabilityBundles","accessSource"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","slug","effectiveRoleLabel","capabilityBundles","accessSource"]}}},"nextCursor":{"anyOf":[{"$ref":"#/components/schemas/Cursor"},{"type":"null"}]}},"required":["items","nextCursor"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","nextCursor"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /agent/workspaces/resolve
Operation ID: `agent.resolveWorkspace`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"workspaceId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"slug":{"$ref":"#/components/schemas/ShortText"}},"additionalProperties":false,"propertyNames":{"type":"string","enum":["workspaceId","slug"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/ShortText"},"slug":{"$ref":"#/components/schemas/ShortText"},"effectiveRoleLabel":{"$ref":"#/components/schemas/ShortText"},"capabilityBundles":{"type":"array","items":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}},"accessSource":{"type":"string","enum":["membership","organization","credential"]}},"required":["id","name","slug","effectiveRoleLabel","capabilityBundles","accessSource"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","slug","effectiveRoleLabel","capabilityBundles","accessSource"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
## agentCapabilities
### GET /agent/capability-bundles
Operation ID: `agent.listCapabilityBundles`
Parameters:
- `cursor` (query): `Cursor`
- `limit` (query): `{"type":"string"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},"title":{"$ref":"#/components/schemas/ShortText"},"capabilities":{"type":"array","items":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}}},"required":["id","title","capabilities"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","title","capabilities"]}}},"nextCursor":{"anyOf":[{"$ref":"#/components/schemas/Cursor"},{"type":"null"}]}},"required":["items","nextCursor"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","nextCursor"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /agent/capabilities
Operation ID: `agent.listCapabilities`
Parameters:
- `cursor` (query): `Cursor`
- `limit` (query): `{"type":"string"}`
- `feature` (query): `{"type":"string","minLength":1}`
- `risk` (query): `{"type":"string","enum":["read","write","costly","destructive","security_admin"]}`
- `availability` (query): `{"type":"string","enum":["available","scope_required","permission_denied","feature_disabled","subscription_blocked","human_completion_required","temporarily_unavailable"]}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},"feature":{"$ref":"#/components/schemas/NonEmptyString"},"purpose":{"$ref":"#/components/schemas/Description"},"prerequisites":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}},"kind":{"type":"string","enum":["direct_tool","mcp_resource","async_operation","preview_commit","user_completion","human_only"]},"risk":{"type":"string","enum":["read","write","costly","destructive","security_admin"]},"scopes":{"type":"array","items":{"type":"string","enum":["agent:capabilities","agent:identity","agent:operations:cancel","agent:operations:read","analytics:export","analytics:read","apiKey:create","apiKey:delete","apiKey:read","apiKey:update","audit:read","billing:manage","billing:read","blocklist:create","blocklist:delete","blocklist:read","campaign:archive","campaign:create","campaign:delete","campaign:launch","campaign:pause","campaign:read","campaign:update","dialer:assign_numbers","dialer:assign_seats","dialer:create","dialer:delete","dialer:dial","dialer:manage_billing","dialer:manage_number_health","dialer:manage_numbers","dialer:manage_numbers_self","dialer:manage_voicemails","dialer:read","dialer:read_analytics","dialer:read_numbers_all","dialer:release_numbers","dialer:update","domain:manage_dns","domain:purchase","domain:read","domain:transfer","emailVerification:manage_credits","emailVerification:manage_keys","emailVerification:manage_sharing","emailVerification:read","emailVerification:verify","inbox:connect","inbox:create","inbox:delete","inbox:read","inbox:update","inbox:warmup_manage","integration:create","integration:delete","integration:read","integration:update","lead:create","lead:delete","lead:export","lead:import","lead:read","lead:update","leadList:create","leadList:delete","leadList:read","leadList:update","org:delete","orgAnalytics:read","orgAnalytics:manage","org:read","org:update","orgApiKey:manage","orgMember:invite","orgMember:read","orgMember:remove","orgMember:update","phoneVerification:manage_keys","phoneVerification:read","phoneVerification:verify","platform:operate","replyLabel:create","replyLabel:delete","replyLabel:read","replyLabel:update","role:manage","role:read","sequence:create","sequence:delete","sequence:read","sequence:update","sql:manage_dashboards","sql:query","support:create","support:read","support:update","tag:create","tag:delete","tag:read","tag:update","task:create","task:delete","task:read","task:update","template:create","template:delete","template:read","template:update","unibox:archive","unibox:label","unibox:read","unibox:reply","usage:read","webhook:create","webhook:delete","webhook:read","webhook:update","whiteLabel:read","whiteLabel:update","workflow:create","workflow:delete","workflow:publish","workflow:read","workflow:run","workflow:update","workspace:create","workspace:delete","workspace:read","workspace:transfer","workspace:update","workspaceMember:invite","workspaceMember:read","workspaceMember:remove","workspaceMember:update"]}},"confirmation":{"type":"string","enum":["none","explicit","preview_token","human_completion"]},"resultMode":{"type":"string","enum":["inline","page","operation_handle","stream","download","redirect"]},"availability":{"type":"object","properties":{"state":{"type":"string","enum":["available","scope_required","permission_denied","feature_disabled","subscription_blocked","human_completion_required","temporarily_unavailable"]},"reason":{"$ref":"#/components/schemas/ShortText"}},"required":["state"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["state","reason"]}},"inputFields":{"type":"array","items":{"$ref":"#/components/schemas/NonEmptyString"}},"outputBounds":{"type":"object","properties":{"maxItems":{"type":"integer","minimum":0,"maximum":9007199254740991},"maxBytes":{"type":"integer","exclusiveMinimum":0}},"required":["maxItems","maxBytes"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["maxItems","maxBytes"]}},"bundles":{"type":"array","items":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}}},"required":["id","feature","purpose","prerequisites","kind","risk","scopes","confirmation","resultMode","availability","inputFields","outputBounds","bundles"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","feature","purpose","prerequisites","kind","risk","scopes","confirmation","resultMode","availability","inputFields","outputBounds","bundles"]}}},"nextCursor":{"anyOf":[{"$ref":"#/components/schemas/Cursor"},{"type":"null"}]}},"required":["items","nextCursor"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","nextCursor"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /agent/capabilities/{capabilityId}
Operation ID: `agent.getCapability`
Parameters:
- `capabilityId` (path, required): `{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},"feature":{"$ref":"#/components/schemas/NonEmptyString"},"purpose":{"$ref":"#/components/schemas/Description"},"prerequisites":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}},"kind":{"type":"string","enum":["direct_tool","mcp_resource","async_operation","preview_commit","user_completion","human_only"]},"risk":{"type":"string","enum":["read","write","costly","destructive","security_admin"]},"scopes":{"type":"array","items":{"type":"string","enum":["agent:capabilities","agent:identity","agent:operations:cancel","agent:operations:read","analytics:export","analytics:read","apiKey:create","apiKey:delete","apiKey:read","apiKey:update","audit:read","billing:manage","billing:read","blocklist:create","blocklist:delete","blocklist:read","campaign:archive","campaign:create","campaign:delete","campaign:launch","campaign:pause","campaign:read","campaign:update","dialer:assign_numbers","dialer:assign_seats","dialer:create","dialer:delete","dialer:dial","dialer:manage_billing","dialer:manage_number_health","dialer:manage_numbers","dialer:manage_numbers_self","dialer:manage_voicemails","dialer:read","dialer:read_analytics","dialer:read_numbers_all","dialer:release_numbers","dialer:update","domain:manage_dns","domain:purchase","domain:read","domain:transfer","emailVerification:manage_credits","emailVerification:manage_keys","emailVerification:manage_sharing","emailVerification:read","emailVerification:verify","inbox:connect","inbox:create","inbox:delete","inbox:read","inbox:update","inbox:warmup_manage","integration:create","integration:delete","integration:read","integration:update","lead:create","lead:delete","lead:export","lead:import","lead:read","lead:update","leadList:create","leadList:delete","leadList:read","leadList:update","org:delete","orgAnalytics:read","orgAnalytics:manage","org:read","org:update","orgApiKey:manage","orgMember:invite","orgMember:read","orgMember:remove","orgMember:update","phoneVerification:manage_keys","phoneVerification:read","phoneVerification:verify","platform:operate","replyLabel:create","replyLabel:delete","replyLabel:read","replyLabel:update","role:manage","role:read","sequence:create","sequence:delete","sequence:read","sequence:update","sql:manage_dashboards","sql:query","support:create","support:read","support:update","tag:create","tag:delete","tag:read","tag:update","task:create","task:delete","task:read","task:update","template:create","template:delete","template:read","template:update","unibox:archive","unibox:label","unibox:read","unibox:reply","usage:read","webhook:create","webhook:delete","webhook:read","webhook:update","whiteLabel:read","whiteLabel:update","workflow:create","workflow:delete","workflow:publish","workflow:read","workflow:run","workflow:update","workspace:create","workspace:delete","workspace:read","workspace:transfer","workspace:update","workspaceMember:invite","workspaceMember:read","workspaceMember:remove","workspaceMember:update"]}},"confirmation":{"type":"string","enum":["none","explicit","preview_token","human_completion"]},"resultMode":{"type":"string","enum":["inline","page","operation_handle","stream","download","redirect"]},"availability":{"type":"object","properties":{"state":{"type":"string","enum":["available","scope_required","permission_denied","feature_disabled","subscription_blocked","human_completion_required","temporarily_unavailable"]},"reason":{"$ref":"#/components/schemas/ShortText"}},"required":["state"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["state","reason"]}},"inputFields":{"type":"array","items":{"$ref":"#/components/schemas/NonEmptyString"}},"outputBounds":{"type":"object","properties":{"maxItems":{"type":"integer","minimum":0,"maximum":9007199254740991},"maxBytes":{"type":"integer","exclusiveMinimum":0}},"required":["maxItems","maxBytes"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["maxItems","maxBytes"]}},"bundles":{"type":"array","items":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}},"inputSchema":{"$ref":"#/components/schemas/Union_"},"outputSchema":{"$ref":"#/components/schemas/Union_"},"errorCodes":{"type":"array","items":{"$ref":"#/components/schemas/NonEmptyString"}},"guidance":{"type":"object","properties":{"whenToUse":{"$ref":"#/components/schemas/Description"},"whenNotToUse":{"$ref":"#/components/schemas/Description"}},"required":["whenToUse","whenNotToUse"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["whenToUse","whenNotToUse"]}}},"required":["id","feature","purpose","prerequisites","kind","risk","scopes","confirmation","resultMode","availability","inputFields","outputBounds","bundles","inputSchema","outputSchema","errorCodes","guidance"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","feature","purpose","prerequisites","kind","risk","scopes","confirmation","resultMode","availability","inputFields","outputBounds","bundles","inputSchema","outputSchema","errorCodes","guidance"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
## agentConfirmations
### POST /agent/confirmations
Operation ID: `agent.prepareConfirmation`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"capabilityId":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},"workspaceId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"input":{"$ref":"#/components/schemas/Union_"}},"required":["capabilityId","workspaceId","input"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["capabilityId","workspaceId","input"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"preview":{"type":"object","properties":{"summary":{"$ref":"#/components/schemas/Description"},"affected":{"type":"object","properties":{"resourceCounts":{"type":"array","items":{"type":"object","properties":{"type":{"$ref":"#/components/schemas/NonEmptyString"},"count":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["type","count"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["type","count"]}},"maxItems":64},"resourceIds":{"type":"array","items":{"$ref":"#/components/schemas/OpaqueId"},"maxItems":256}},"required":["resourceCounts","resourceIds"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["resourceCounts","resourceIds"]}},"costEstimate":{"type":"object","properties":{"min":{"$ref":"#/components/schemas/Money"},"max":{"$ref":"#/components/schemas/Money"}},"required":["min","max"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["min","max"]}},"warnings":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"},"maxItems":32},"irreversibleFacts":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"},"maxItems":32},"inputHash":{"$ref":"#/components/schemas/OpaqueId"},"previewVersion":{"$ref":"#/components/schemas/NonEmptyString"},"expiresAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["summary","affected","warnings","irreversibleFacts","inputHash","previewVersion","expiresAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["summary","affected","costEstimate","warnings","irreversibleFacts","inputHash","previewVersion","expiresAt"]}},"confirmationToken":{"$ref":"#/components/schemas/OpaqueId"}},"required":["preview","confirmationToken"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["preview","confirmationToken"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `409` Conflict | ConfirmationInvalid
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
## operations
### GET /agent/operations/{operationId}
Operation ID: `agent.getOperation`
Parameters:
- `operationId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"capabilityId":{"anyOf":[{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},{"type":"null"}]},"workspaceId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"state":{"type":"string","enum":["queued","running","waiting_for_user","succeeded","partially_succeeded","failed","canceled","canceling"]},"statusUrl":{"anyOf":[{"$ref":"#/components/schemas/HttpUrl"},{"$ref":"#/components/schemas/HttpResourcePath"}]},"submittedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"startedAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]},"completedAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]},"progress":{"type":"object","properties":{"completed":{"type":"integer","minimum":0},"total":{"type":"integer","minimum":0},"message":{"$ref":"#/components/schemas/NonEmptyString"}},"required":["completed"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["completed","total","message"]}},"canCancel":{"type":"boolean"},"failure":{"type":"object","properties":{"code":{"$ref":"#/components/schemas/NonEmptyString"},"safeMessage":{"$ref":"#/components/schemas/ShortText"},"retryable":{"type":"boolean"},"retryAfter":{"type":"integer","minimum":0,"maximum":9007199254740991},"recoveryCapability":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"}},"required":["code","safeMessage","retryable"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["code","safeMessage","retryable","retryAfter","recoveryCapability"]}},"result":{"anyOf":[{"type":"object","properties":{"capabilityId":{"type":"string","pattern":"^[a-z][a-z0-9_]{0,63}$"},"href":{"anyOf":[{"$ref":"#/components/schemas/HttpUrl"},{"$ref":"#/components/schemas/HttpResourcePath"}]}},"required":["capabilityId","href"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["capabilityId","href"]}},{"type":"object","properties":{"providerOperation":{"type":"string","enum":["usage","enrich_email","enrich_linkedin","enrich_person","lookup_phone","search","count","export","export_status","profiles","profile_leads","set_profile_active"]},"results":{"type":"array","items":{"type":"object","properties":{"index":{"type":"integer","minimum":0},"outcome":{"type":"string","enum":["ok","failed","skipped"]},"value":{"anyOf":[{"type":"null"},{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"array","items":{"$ref":"#/components/schemas/Union_"}},{"type":"object","additionalProperties":{"$ref":"#/components/schemas/Union_"}}]},"errorCode":{"$ref":"#/components/schemas/NonEmptyString"}},"required":["index","outcome"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["index","outcome","value","errorCode"]}},"maxItems":100}},"required":["providerOperation","results"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["providerOperation","results"]}}]}},"required":["id","capabilityId","workspaceId","state","statusUrl","submittedAt","startedAt","completedAt","canCancel"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","capabilityId","workspaceId","state","statusUrl","submittedAt","startedAt","completedAt","progress","canCancel","failure","result"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /agent/operations/{operationId}/cancel
Operation ID: `agent.cancelOperation`
Parameters:
- `operationId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"cancellation":{"type":"string","enum":["supported","requested","terminal"]},"state":{"type":"string","enum":["queued","running","waiting_for_user","succeeded","partially_succeeded","failed","canceled","canceling"]}},"required":["id","cancellation","state"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","cancellation","state"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | AgentScopeDenied | WorkspaceAccessDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
## leads
### GET /v1/workspaces/{workspaceId}/leads
Operation ID: `leads.list`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `offset` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `limit` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `search` (query): `NonEmptyString`
- `sortBy` (query): `{"type":"string","enum":["firstName","lastName","company","createdAt","updatedAt","email"]}`
- `sortOrder` (query): `{"type":"string","enum":["asc","desc"]}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"email":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"company":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneNumber":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"city":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"state":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"country":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"timezone":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"customFieldValues":{"type":"object","propertyNames":{"$ref":"#/components/schemas/LeadStoredText"},"additionalProperties":{"type":"string"}},"ladder":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"rank":{"anyOf":[{"type":"integer","minimum":0,"maximum":9007199254740991},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"emails":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"phones":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"activity":{"type":"object","properties":{"campaignCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"emailCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"replyCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"callCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"recordingCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"lastActivityAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["campaignCount","emailCount","replyCount","callCount","recordingCount","lastActivityAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["campaignCount","emailCount","replyCount","callCount","recordingCount","lastActivityAt"]}}},"required":["id","email","firstName","lastName","company","phoneNumber","jobTitle","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","ladder","rank","createdAt","updatedAt","emails","phones","activity"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","email","firstName","lastName","company","phoneNumber","jobTitle","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","ladder","rank","createdAt","updatedAt","emails","phones","activity"]}}},"activityVisibility":{"type":"object","properties":{"campaigns":{"type":"boolean"},"replies":{"type":"boolean"},"calls":{"type":"boolean"}},"required":["campaigns","replies","calls"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["campaigns","replies","calls"]}},"pagination":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"maximum":9007199254740991},"limit":{"type":"integer","minimum":0,"maximum":9007199254740991},"total":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["offset","limit","total"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["offset","limit","total"]}}},"required":["items","activityVisibility","pagination"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","activityVisibility","pagination"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/import
Operation ID: `leads.import`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"leadListId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"rows":{"type":"array","items":{"type":"object","properties":{"acquisitionSource":{"type":"string","maxLength":256},"email":{"$ref":"#/components/schemas/EmailAddress"},"firstName":{"type":"string","maxLength":256},"lastName":{"type":"string","maxLength":256},"company":{"type":"string","maxLength":256},"city":{"type":"string","maxLength":256},"state":{"type":"string","maxLength":256},"country":{"type":"string","maxLength":256},"customFields":{"$ref":"#/components/schemas/LeadCustomFieldValues"},"emails":{"type":"array","items":{"$ref":"#/components/schemas/EmailAddress"}},"phones":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}},"ladder":{"type":"string","maxLength":256},"rank":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["email","firstName","lastName"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["acquisitionSource","email","firstName","lastName","company","city","state","country","customFields","emails","phones","ladder","rank"]}},"maxItems":10000}},"required":["leadListId","rows"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["leadListId","rows"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"imported":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["imported"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["imported"]}]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/by-campaign/{campaignId}
Operation ID: `leads.listByCampaign`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `campaignId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `offset` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `limit` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `search` (query): `NonEmptyString`
- `sortBy` (query): `{"type":"string","enum":["email","firstName","lastName","company","createdAt"]}`
- `sortOrder` (query): `{"type":"string","enum":["asc","desc"]}`
- `assigneeUserIds` (query): `{"type":"string"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"leadId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"email":{"$ref":"#/components/schemas/LeadStoredText"},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"company":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyDomain":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"city":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"state":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"country":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"timezone":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"customFieldValues":{"type":"object","propertyNames":{"$ref":"#/components/schemas/LeadStoredText"},"additionalProperties":{"type":"string"}},"status":{"type":"string","enum":["not_contacted","contacted","completed","task_pending","task_failed","paused","out_of_office","bounced","unsubscribed","ladder_queued","moved_to_subsequence"]},"bounceCategory":{"anyOf":[{"type":"string","enum":["recipient","sender"]},{"type":"null"}]},"recipientEsp":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"emailSecurityGateway":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"assignees":{"type":"array","items":{"type":"object","properties":{"userId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"email":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"image":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"isFormerMember":{"type":"boolean"}},"required":["userId","name","email","image","isFormerMember"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["userId","name","email","image","isFormerMember"]}}},"labels":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string"},"name":{"$ref":"#/components/schemas/ShortText"},"hexColor":{"$ref":"#/components/schemas/ShortText"},"sentiment":{"anyOf":[{"$ref":"#/components/schemas/ShortText"},{"type":"null"}]},"type":{"type":"string","enum":["custom","default"]}},"required":["id","name","hexColor","sentiment","type"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","hexColor","sentiment","type"]}}}},"required":["id","leadId","email","firstName","lastName","company","jobTitle","companyDomain","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","status","recipientEsp","emailSecurityGateway","assignees","labels"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","leadId","email","firstName","lastName","company","jobTitle","companyDomain","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","status","bounceCategory","recipientEsp","emailSecurityGateway","assignees","labels"]}}},"pagination":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"maximum":9007199254740991},"limit":{"type":"integer","minimum":0,"maximum":9007199254740991},"total":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["offset","limit","total"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["offset","limit","total"]}}},"required":["items","pagination"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","pagination"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/by-list/{leadListId}
Operation ID: `leads.listByList`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadListId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `offset` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `limit` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
- `search` (query): `NonEmptyString`
- `sortBy` (query): `{"type":"string","enum":["email","firstName","lastName","company","createdAt","ladder","rank"]}`
- `sortOrder` (query): `{"type":"string","enum":["asc","desc"]}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"email":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"company":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneNumber":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"city":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"state":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"country":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"timezone":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"customFieldValues":{"type":"object","propertyNames":{"$ref":"#/components/schemas/LeadStoredText"},"additionalProperties":{"type":"string"}},"ladder":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"rank":{"anyOf":[{"type":"integer","minimum":0,"maximum":9007199254740991},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"emails":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"phones":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"activity":{"type":"object","properties":{"campaignCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"emailCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"replyCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"callCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"recordingCount":{"type":"integer","minimum":0,"maximum":9007199254740991},"lastActivityAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["campaignCount","emailCount","replyCount","callCount","recordingCount","lastActivityAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["campaignCount","emailCount","replyCount","callCount","recordingCount","lastActivityAt"]}}},"required":["id","email","firstName","lastName","company","phoneNumber","jobTitle","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","ladder","rank","createdAt","updatedAt","emails","phones","activity"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","email","firstName","lastName","company","phoneNumber","jobTitle","companyWebsiteUrl","personalLinkedInUrl","companyLinkedInUrl","city","state","country","timezone","customFieldValues","ladder","rank","createdAt","updatedAt","emails","phones","activity"]}}},"pagination":{"type":"object","properties":{"offset":{"type":"integer","minimum":0,"maximum":9007199254740991},"limit":{"type":"integer","minimum":0,"maximum":9007199254740991},"total":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["offset","limit","total"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["offset","limit","total"]}}},"required":["items","pagination"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","pagination"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/bulk
Operation ID: `leads.bulkCreate`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"leadListId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"syncToAttio":{"type":"boolean"},"leads":{"type":"array","items":{"type":"object","properties":{"acquisitionSource":{"type":"string","maxLength":256},"email":{"$ref":"#/components/schemas/NonEmptyString"},"firstName":{"type":"string","maxLength":256},"lastName":{"type":"string","maxLength":256},"company":{"type":"string","maxLength":256},"city":{"type":"string","maxLength":256},"state":{"type":"string","maxLength":256},"country":{"type":"string","maxLength":256},"customFieldValues":{"$ref":"#/components/schemas/LeadCustomFieldValues"},"emails":{"type":"array","items":{"$ref":"#/components/schemas/EmailAddress"}},"phones":{"type":"array","items":{"$ref":"#/components/schemas/LeadPhoneValue"}},"ladder":{"$ref":"#/components/schemas/ShortText"},"rank":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["email","firstName","lastName"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["acquisitionSource","email","firstName","lastName","company","city","state","country","customFieldValues","emails","phones","ladder","rank"]}},"maxItems":10000}},"required":["leadListId","leads"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["leadListId","syncToAttio","leads"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"created":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["created"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["created"]}]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/{leadId}
Operation ID: `leads.get`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"organizationId":{"type":"string"},"emailAddress":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneNumber":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneBase":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneExtension":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"locality":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"region":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"country":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"timezone":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"source":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"customFieldValues":{"anyOf":[{"type":"object","propertyNames":{"$ref":"#/components/schemas/ShortText"},"additionalProperties":{"$ref":"#/components/schemas/Union_"}},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","organizationId","emailAddress","phoneNumber","phoneBase","phoneExtension","firstName","lastName","companyName","companyWebsiteUrl","jobTitle","locality","region","country","timezone","personalLinkedInUrl","companyLinkedInUrl","source","customFieldValues","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","organizationId","emailAddress","phoneNumber","phoneBase","phoneExtension","firstName","lastName","companyName","companyWebsiteUrl","jobTitle","locality","region","country","timezone","personalLinkedInUrl","companyLinkedInUrl","source","customFieldValues","createdAt","updatedAt"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### PATCH /v1/workspaces/{workspaceId}/leads/{leadId}
Operation ID: `leads.update`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"firstName":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"lastName":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"companyName":{"anyOf":[{"type":"string","maxLength":500},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"type":"string","maxLength":2048},{"type":"null"}]},"jobTitle":{"anyOf":[{"type":"string","maxLength":500},{"type":"null"}]},"locality":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"region":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"country":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"timezone":{"anyOf":[{"type":"string","maxLength":255},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"type":"string","maxLength":2048},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"type":"string","maxLength":2048},{"type":"null"}]}},"additionalProperties":false,"propertyNames":{"type":"string","enum":["firstName","lastName","companyName","companyWebsiteUrl","jobTitle","locality","region","country","timezone","personalLinkedInUrl","companyLinkedInUrl"]},"minProperties":1,"maxProperties":11}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"organizationId":{"type":"string"},"emailAddress":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneNumber":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneBase":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneExtension":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyWebsiteUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"locality":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"region":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"country":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"timezone":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"personalLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyLinkedInUrl":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"source":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"customFieldValues":{"anyOf":[{"type":"object","propertyNames":{"$ref":"#/components/schemas/ShortText"},"additionalProperties":{"$ref":"#/components/schemas/Union_"}},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","organizationId","emailAddress","phoneNumber","phoneBase","phoneExtension","firstName","lastName","companyName","companyWebsiteUrl","jobTitle","locality","region","country","timezone","personalLinkedInUrl","companyLinkedInUrl","source","customFieldValues","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","organizationId","emailAddress","phoneNumber","phoneBase","phoneExtension","firstName","lastName","companyName","companyWebsiteUrl","jobTitle","locality","region","country","timezone","personalLinkedInUrl","companyLinkedInUrl","source","customFieldValues","createdAt","updatedAt"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/{leadId}/timeline
Operation ID: `leads.timeline`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `cursor` (query): `Cursor`
- `limit` (query): `{"type":"string","pattern":"^[+-]?\\d*\\.?\\d+(?:[Ee][+-]?\\d+)?$"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"events":{"type":"array","items":{"anyOf":[{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["campaign_enrolled"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"campaignId":{"type":"string"},"campaignName":{"$ref":"#/components/schemas/LeadStoredText"},"status":{"type":"string","enum":["not_contacted","contacted","completed","task_pending","task_failed","paused","out_of_office","bounced","unsubscribed","ladder_queued","moved_to_subsequence"]},"bounceCategory":{"anyOf":[{"type":"string","enum":["recipient","sender"]},{"type":"null"}]},"emailAddress":{"$ref":"#/components/schemas/LeadStoredText"}},"required":["kind","occurredAt","sortId","campaignId","campaignName","status","emailAddress"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","campaignId","campaignName","status","bounceCategory","emailAddress"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["email_sent"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"campaignId":{"anyOf":[{"type":"string"},{"type":"null"}]},"campaignName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"threadId":{"anyOf":[{"type":"string"},{"type":"null"}]},"openCount":{"anyOf":[{"type":"integer","minimum":0,"maximum":9007199254740991},{"type":"null"}]},"firstOpenedAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["kind","occurredAt","sortId","campaignId","campaignName","threadId","openCount","firstOpenedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","campaignId","campaignName","threadId","openCount","firstOpenedAt"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["email_opened"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"campaignName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"openCount":{"anyOf":[{"type":"integer","minimum":0,"maximum":9007199254740991},{"type":"null"}]}},"required":["kind","occurredAt","sortId","campaignName","openCount"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","campaignName","openCount"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["email_replied"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"from":{"$ref":"#/components/schemas/LeadStoredText"},"subject":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"snippet":{"type":"string"},"threadId":{"type":"string"}},"required":["kind","occurredAt","sortId","from","subject","snippet","threadId"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","from","subject","snippet","threadId"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["task"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"title":{"$ref":"#/components/schemas/LeadStoredText"},"completedAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]},"outcome":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]}},"required":["kind","occurredAt","sortId","title","completedAt","outcome"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","title","completedAt","outcome"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["call"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"direction":{"$ref":"#/components/schemas/ShortText"},"status":{"$ref":"#/components/schemas/ShortText"},"durationSeconds":{"anyOf":[{"type":"integer","minimum":0,"maximum":9007199254740991},{"type":"null"}]},"counterpartyPhoneE164":{"$ref":"#/components/schemas/ShortText"},"repUserId":{"anyOf":[{"type":"string"},{"type":"null"}]},"repName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"disposition":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"note":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"hasRecording":{"type":"boolean"},"hasTranscript":{"type":"boolean"},"aiSummary":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]}},"required":["kind","occurredAt","sortId","direction","status","durationSeconds","counterpartyPhoneE164","repUserId","repName","disposition","note","hasRecording","hasTranscript","aiSummary"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","direction","status","durationSeconds","counterpartyPhoneE164","repUserId","repName","disposition","note","hasRecording","hasTranscript","aiSummary"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["contact_point"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"pointKind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/LeadStoredText"},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]}},"required":["kind","occurredAt","sortId","pointKind","value","badReason"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","pointKind","value","badReason"]}},{"type":"object","properties":{"kind":{"anyOf":[{"type":"string","enum":["crm_note_pushed"]}]},"occurredAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"sortId":{"type":"string"},"provider":{"$ref":"#/components/schemas/ShortText"},"sourceKind":{"$ref":"#/components/schemas/ShortText"}},"required":["kind","occurredAt","sortId","provider","sourceKind"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","occurredAt","sortId","provider","sourceKind"]}}]}},"nextCursor":{"anyOf":[{"$ref":"#/components/schemas/Cursor"},{"type":"null"}]},"hiddenSources":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}},"undatedEnrollments":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["events","nextCursor","hiddenSources","undatedEnrollments"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["events","nextCursor","hiddenSources","undatedEnrollments"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/search
Operation ID: `leads.search`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"query":{"type":"string","minLength":1,"maxLength":200},"limit":{"type":"integer","minimum":1,"maximum":25}},"required":["query"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["query","limit"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"leads":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"firstName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"lastName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"companyName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"jobTitle":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"emailAddress":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"phoneNumber":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"source":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]}},"required":["id","firstName","lastName","companyName","jobTitle","emailAddress","phoneNumber","source"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","firstName","lastName","companyName","jobTitle","emailAddress","phoneNumber","source"]}},"maxItems":25}},"required":["leads"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["leads"]}]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/{leadId}/contact-points
Operation ID: `leads.contactPoints`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"emails":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"phones":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"kind":{"type":"string","enum":["email","phone"]},"value":{"$ref":"#/components/schemas/NonEmptyString"},"contactType":{"$ref":"#/components/schemas/LeadStoredText"},"sourceValue":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"position":{"type":"integer","exclusiveMinimum":0},"status":{"type":"string","enum":["active","bad"]},"badReason":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"badAt":{"anyOf":[{"$ref":"#/components/schemas/UtcDateTimeEncoded"},{"type":"null"}]}},"required":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","kind","value","contactType","sourceValue","position","status","badReason","badAt"]}}},"ladder":{"anyOf":[{"type":"object","properties":{"id":{"type":"string"},"key":{"$ref":"#/components/schemas/ShortText"},"rank":{"type":"integer","minimum":0,"maximum":9007199254740991}},"required":["id","key","rank"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","key","rank"]}},{"type":"null"}]}},"required":["emails","phones","ladder"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["emails","phones","ladder"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/{leadId}/contact-points/status
Operation ID: `leads.setContactPointStatus`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"kind":{"type":"string","enum":["email","phone"]},"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"status":{"type":"string","enum":["active","bad"]}},"required":["kind","id","status"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","id","status"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"success":{"anyOf":[{"type":"boolean","enum":[true]}]}},"required":["success"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["success"]}]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/{leadId}/contact-points/reorder
Operation ID: `leads.reorderContactPoints`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"kind":{"type":"string","enum":["email","phone"]},"orderedIds":{"type":"array","items":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"minItems":1}},"required":["kind","orderedIds"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["kind","orderedIds"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"success":{"anyOf":[{"type":"boolean","enum":[true]}]}},"required":["success"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["success"]}]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/leads/{leadId}/notes
Operation ID: `leads.notes.list`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `cursorAt` (query): `UtcDateTimeEncoded`
- `cursorId` (query): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"items":{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"leadId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"body":{"type":"string"},"authorUserId":{"anyOf":[{"type":"string"},{"type":"null"}]},"authorName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","leadId","body","authorUserId","authorName","createdAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","leadId","body","authorUserId","authorName","createdAt"]}},"maxItems":50},"nextCursor":{"anyOf":[{"type":"object","properties":{"at":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}},"required":["at","id"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["at","id"]}},{"type":"null"}]}},"required":["items","nextCursor"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["items","nextCursor"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/{leadId}/notes
Operation ID: `leads.notes.add`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"body":{"type":"string","minLength":1,"maxLength":20000}},"required":["body"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["body"]}]}}
```
Responses:
- `201` Success
```json
{"type":"object","properties":{"note":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"leadId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"body":{"type":"string"},"authorUserId":{"anyOf":[{"type":"string"},{"type":"null"}]},"authorName":{"anyOf":[{"$ref":"#/components/schemas/LeadStoredText"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","leadId","body","authorUserId","authorName","createdAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","leadId","body","authorUserId","authorName","createdAt"]}}},"required":["note"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["note"]}]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### DELETE /v1/workspaces/{workspaceId}/leads/{leadId}/notes/{noteId}
Operation ID: `leads.notes.remove`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `noteId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"success":{"anyOf":[{"type":"boolean","enum":[true]}]}},"required":["success"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["success"]}]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/leads/{leadId}/emails
Operation ID: `leads.addEmail`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `leadId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"email":{"$ref":"#/components/schemas/EmailAddress"}},"required":["email"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["email"]}]}}
```
Responses:
- `201` Success
```json
{"type":"object","properties":{"success":{"anyOf":[{"type":"boolean","enum":[true]}]}},"required":["success"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["success"]}]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
## leadLists
### POST /v1/workspaces/{workspaceId}/lead-lists
Operation ID: `leadLists.create`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"name":{"$ref":"#/components/schemas/NonEmptyString"},"customFieldNames":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}},"folderId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}},"required":["name"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["name","customFieldNames","folderId"]}}
```
Responses:
- `201` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"customFieldNames":{"anyOf":[{"type":"array","items":{"$ref":"#/components/schemas/LeadStoredText"}},{"type":"null"}]},"folderId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","customFieldNames","folderId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","customFieldNames","folderId","createdAt","updatedAt"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/lead-lists
Operation ID: `leadLists.list`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"array","items":{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"customFieldNames":{"anyOf":[{"type":"array","items":{"$ref":"#/components/schemas/LeadStoredText"}},{"type":"null"}]},"folderId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","customFieldNames","folderId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","customFieldNames","folderId","createdAt","updatedAt"]}}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### POST /v1/workspaces/{workspaceId}/lead-lists/folders
Operation ID: `leadLists.createFolder`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"name":{"$ref":"#/components/schemas/NonEmptyString"},"parentId":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}},"required":["name"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["name","parentId"]}}
```
Responses:
- `201` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"parentId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","parentId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","parentId","createdAt","updatedAt"]}}
```
- `400` InvalidRequest
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `409` Conflict
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/lead-lists/tree
Operation ID: `leadLists.tree`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` LeadListTree
Schema: `LeadListTree` (see Schemas).
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### GET /v1/workspaces/{workspaceId}/lead-lists/{listId}
Operation ID: `leadLists.get`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `listId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"customFieldNames":{"anyOf":[{"type":"array","items":{"$ref":"#/components/schemas/LeadStoredText"}},{"type":"null"}]},"folderId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","customFieldNames","folderId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","customFieldNames","folderId","createdAt","updatedAt"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### PATCH /v1/workspaces/{workspaceId}/lead-lists/{listId}
Operation ID: `leadLists.update`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `listId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"name":{"$ref":"#/components/schemas/NonEmptyString"},"customFieldNames":{"type":"array","items":{"$ref":"#/components/schemas/ShortText"}}},"required":["name"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["name","customFieldNames"]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"customFieldNames":{"anyOf":[{"type":"array","items":{"$ref":"#/components/schemas/LeadStoredText"}},{"type":"null"}]},"folderId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","customFieldNames","folderId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","customFieldNames","folderId","createdAt","updatedAt"]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `404` NotFound
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### DELETE /v1/workspaces/{workspaceId}/lead-lists/{listId}
Operation ID: `leadLists.delete`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `listId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Responses:
- `200` Success
```json
{"type":"object","properties":{"success":{"anyOf":[{"type":"boolean","enum":[true]}]}},"required":["success"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["success"]}]}}
```
- `401` Unauthenticated
- `403` PermissionDenied | WorkspaceAccessDenied | AgentScopeDenied
- `429` RateLimited
- `500` InternalError
- `502` ProviderUnavailable
- `503` TemporarilyUnavailable
### PATCH /v1/workspaces/{workspaceId}/lead-lists/folders/{folderId}
Operation ID: `leadLists.updateFolder`
Parameters:
- `workspaceId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
- `folderId` (path, required): `{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"}`
Request body (`application/json`, required):
```json
{"type":"object","properties":{"name":{"$ref":"#/components/schemas/NonEmptyString"}},"required":["name"],"additionalProperties":false,"propertyNames":{"anyOf":[{"type":"string","enum":["name"]}]}}
```
Responses:
- `200` Success
```json
{"type":"object","properties":{"id":{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},"name":{"$ref":"#/components/schemas/LeadStoredText"},"parentId":{"anyOf":[{"type":"string","pattern":"^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|[fF]{8}-[fF]{4}-[fF]{4}-[fF]{4}-[fF]{12})$","format":"uuid"},{"type":"null"}]},"createdAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"},"updatedAt":{"$ref":"#/components/schemas/UtcDateTimeEncoded"}},"required":["id","name","parentId","createdAt","updatedAt"],"additionalProperties":false,"propertyNames":{"type":"string","enum":["id","name","parentId","createdAt","updatedAt"]}}
```
[...]
